package org.sfb441.tokenizer;
%%
%buffer 16384

%unicode  
%class TokenizerGeneral
%type Object    
%eofval{     
  return null;   
%eofval}
 
%state SENTENCE  

    EndSentence = [\.\:\,\;\(\)\?\!\\]
    WhiteSpace = [ \t\r\n\f]
    Rest = [\\\{\}\+\-\"]
    Word = ([^\\\t\n\f\r\.\:\,\;\(\)\?\!\\\"\\\{\}\+\- ])
			  
%%
 
<YYINITIAL> {
    .  {  
       yypushback(1);
       yybegin(SENTENCE); 
    }
}
 
<SENTENCE> 
{
// **************** AUSNAHMEN **********************

/*
	Vorbereitet fuer die Behandlung von Satzenden. Dies wird
	allerdings im Moment nicht bentigt.
*/

    // "." gefolgt von "&" ist kein Satzende 
"." / {WhiteSpace}* & {
    return yytext() + "\n";
}

// **************** REGULAER **********************

// Satzende (siehe Makro, z.B. ".", ":"). Nichts Besonderes machen.
{EndSentence}  { 
    return yytext() + "\n";
}


// Whitespace (siehe Makro)
{WhiteSpace}+ { 
    return "";
}

// Restliche zeichen (siehe Makro)
{Rest}+ { 
	return yytext() + "\n";
}


// Non-Whitespace, d.h. Woerter 
{Word}+ {		
	if (yytext().contains("'") | yytext().contains("") 
	    | yytext().contains("") | yytext().contains("`")){
		String word = yytext().replace("", "'");	
		word = word.replace("`", "'");	
		word = word.replace("", "'");	
		int i = word.indexOf("'");
		return yytext().substring(0,i) + "'\n" + yytext().substring(i+1) + "\n";
	} 
    return yytext() + "\n";
}
}
