package org.sfb441.tokenizer;
%%
%buffer 16384

%unicode  
%class TokenizerOldSpanish
%type Object    
%eofval{     
  return null;   
%eofval}
 
%state SENTENCE  

/**
old spanisch dictionary:
*/
    EndSentence = [\.\:\,\;\(\)\?\!\\]
    WhiteSpace = [ \t\r\n\f]
    Rest = [\\\{\}\+\-\"]
    Word = ([^\\\t\n\f\r\.\:\,\;\(\)\?\!\\\"\\\{\}\+\- ])
    Dict = ("agora que") |
    		  ("ahun que") |
    		  ("ante"("s")? (" de" | " que")) |
			  ("as" ("s")? ("i"|"y")  (" como" | " que")) |
			  ("como quier que") |
			  ("desde que") |
			  ("despues " ("desto" | "de" | "que")) |
			  ("desde que") |
			  ("en " ("tal ")? "guisa que") |
			  ("en pos") |
			  ("empero que") |
			  ("en tal manera que") |
			  ("esto mismo") |
			  ("esso mismo") |
			  ("fasta que") |
			  ("junto con esto") |
			  ("luego que") |
			  ("maguer que") |
			  ("mientra que") |
			  ("para que") |
			  ("por " ("consiguiente" | 
			  		   "ende" |
			  		   "esso" |
			  		   "esto" | 
			  		   "que" |
			  		   "lo qual" |
			  		   "tanto" |
			  		   "razon de")) |
			  ("segun que") |
			  (("entre ")? "tanto que") |
			  ("toda via" (" si")?)
			  
%%
 
<YYINITIAL> {
    .  {  
       yypushback(1);
       yybegin(SENTENCE); 
    }
}
 
<SENTENCE> 
{
// **************** AUSNAHMEN **********************

/*
	Vorbereitet fuer die Behandlung von Satzenden. Dies wird
	allerdings im Moment nicht bentigt.
*/

    // "." gefolgt von "&" ist kein Satzende 
"." / {WhiteSpace}* & {
    return yytext() + "\n";
}

// Registrierte Woerter (z.B. mit Leerzeichen)
{Dict} {
    return yytext() + "\n";
}

// **************** REGULAER **********************

// Satzende (siehe Makro, z.B. ".", ":"). Nichts Besonderes machen.
{EndSentence}  { 
    return yytext() + "\n";
}


// Whitespace (siehe Makro)
{WhiteSpace}+ { 
    return "";
}

// Restliche zeichen (siehe Makro)
{Rest}+ { 
	return yytext() + "\n";
}


// Non-Whitespace, d.h. Woerter 
{Word}+ {		
	if (yytext().contains("'") | yytext().contains("") 
	    | yytext().contains("") | yytext().contains("`")){
		String word = yytext().replace("", "'");	
		word = word.replace("`", "'");	
		word = word.replace("", "'");	
		int i = word.indexOf("'");
		return yytext().substring(0,i) + "'\n" + yytext().substring(i+1) + "\n";
	} 
    return yytext() + "\n";
}
}
