package org.sfb441.tokenizer;
%%
%buffer 16384

%unicode  
%class TokenizerOldSpanishSyllablesDict
%type Object    
%eofval{     
  return null;   
%eofval}
 
%state SENTENCE  

/**
old spanisch dictionary:
*/
    EndSentence = [\.\:\,\;\(\)\?\!\\]
    WhiteSpace = [ \t\r\n\f]
    Rest = [\\\{\}\+\-\\"]
    Word = ([^\\\t\n\f\r\.\:\,\;\(\)\?\!\\\"\\\{\}\+\-\ ]) 
			  

%%
 

 
<YYINITIAL> {
    .  {  
       yypushback(1);
       yybegin(SENTENCE); 
    }
}
 
<SENTENCE> 
{

// **************** REGULAER **********************

// Satzende (siehe Makro, z.B. ".", ":"). Nichts Besonderes machen.
{EndSentence}  { 
    return yytext() + "\n";
}


// Whitespace (siehe Makro)
{WhiteSpace}+ { 
    return "";
}

// Restliche zeichen (siehe Makro)
{Rest}+ { 
	return yytext() + "\n";
}


// Non-Whitespace, d.h. Woerter 
{Word}+ {
	if (yytext().contains("'") | yytext().contains("") | yytext().contains("") | yytext().contains("`")){
		String word = yytext().replace("", "'");	
		word = word.replace("`", "'");	
		word = word.replace("", "'");	
		int i = word.indexOf("'");
		//apostroph wird wie ein Buchstabe behandelt
//		return TokenizeUtilities.findSyllables(yytext().substring(0,i), true) 
//		        + "'\n" + TokenizeUtilities.findSyllables(yytext().substring(i+1), true) + "\n";
		return TokenizeUtilities.findSyllables(yytext(), true) + "\n";	
	} else 
		return TokenizeUtilities.findSyllables(yytext(), true) + "\n";	
}



}
