package org.sfb441.tokenizer;
%%
%buffer 16384

%unicode  
%class TokenizerSurselvisch
%type Object    
%eofval{     
  return null;   
%eofval}
 
%state SENTENCE  

/**
Surselvisch dictionary
*/
    EndSentence = [\.\:\,\;\(\)\?\!\\]
    WhiteSpace = [ \t\r\n\f]
    Rest = [\\\{\}\+\-\"]
    Word = ([^\\\t\n\f\r\.\:\,\;\(\)\?\!\\\"\\\{\}\+\- ])
			    
    Dict = (("senza"	|
     		 "per cass" |
    		 "nun" |
    		 "casamei" |
    		 (("a")?"schinavon") |
    		 "supponiu" |
    		 (("a"|"sut la")" cundiziun") |
    		 "priu" |
			 (("per")?"aschilunsch") |
			 ("sco"("chemai")?) |
			 "pli" |
			 "cura" |
			 "enaquella" |
			 "avon" |
			 "ferton" |
			 "dapi" |
			 ("aschi"("spert"|"ditg"|"a")) |
			 ("schi "("spert"|"ditg")) |
			 "suenter" |
			 (("en")?"tochen") |
			 "perquei" |
			 "essend" |
			 "damai" |
			 "cunquei" |
			 ("da "("maniera"|"moda")) |
			 "per" |
			 "sinaquei" |
			 "afin" |
			 "malgrad" |
			 "schegie" |
			 (("sche"|"cum")"bein") |
			 "cuntut")" ch"("e"|"'")) |
			(("mobein"|"sco")" era") |
			(("era"|"sco")" sch"("e"|"'")) |
			(("en consequenza "|"pervia ") ("da"|"dil"|"digl"|"dalla"|"dall'"|"dils"|"dallas")) |
			("ton sco") | 
			("en verdad")		
	  
    		  



%%
 
<YYINITIAL> {
    .  {  
       yypushback(1);
       yybegin(SENTENCE); 
    }
}
 
<SENTENCE> 
{
// **************** AUSNAHMEN **********************

/*
	Vorbereitet fuer die Behandlung von Satzenden. Dies wird
	allerdings im Moment nicht bentigt.
*/

    // "." gefolgt von "&" ist kein Satzende 
"." / {WhiteSpace}* & {
    return yytext() + "\n";
}

// Registrierte Woerter (z.B. mit Leerzeichen)
{Dict} {
    return yytext() + "\n";
}

// **************** REGULAER **********************

// Satzende (siehe Makro, z.B. ".", ":"). Nichts Besonderes machen.
{EndSentence}  { 
    return yytext() + "\n";
}


// Whitespace (siehe Makro)
{WhiteSpace}+ { 
    return "";
}

// Restliche zeichen (siehe Makro)
{Rest}+ { 
	return yytext() + "\n";
}


// Non-Whitespace, d.h. Woerter 
{Word}+ {
	if (yytext().contains("'") | yytext().contains("") | yytext().contains("") | yytext().contains("`")){
		String word = yytext().replace("", "'");	
		word = word.replace("`", "'");	
		word = word.replace("", "'");	
		int i = word.indexOf("'");
		return yytext().substring(0,i) + "'\n" + yytext().substring(i+1) + "\n";
	} 
    return yytext() + "\n";
}
}