package org.sfb441.tradisc;

/*
 * beschreibt ein im Korpus zu verteilendes Tag. Ein Tag ist 
 * im Prinzip eine Tabellenposition im Junktoren-Schema, d.h.
 * ein Tag enthlt eine Spalten- und eine Zeilenangabe fr das 
 * Junktorenschema 
 */
public class Tag {

	private String horiz; // zeile

	private String vert; // spalte

	public Tag() {
		horiz = null;
		vert = null;
	}

	public String getVerticalDim() {
		return vert;
	}

	public String getHorizontalDim() {
		return horiz;
	}

	public void setVerticalDim(String s) {
		vert = s;
	}

	public void setHorizontalDim(String s) {
		horiz = s;
	}

	public static Tag nonTag() {
		Tag t = new Tag();
		t.horiz = "No markable in this context";
		t.vert = "";
		return t;
	}
	
	public boolean isNonMarkableTag(){
		if ((this.horiz.equals("No junctor function") || this.horiz.equals("No markable in this context")) && this.vert.equals("")){
			return true;
		}else return false;
	}
	
	public String toString() {
		if (horiz.length() != 0 && vert.length() != 0)
			return horiz + "-" + vert;
		else
			return horiz + vert;
	}

	public boolean equals(Object o) {
		if (!(o instanceof Tag))
			return false;
		Tag t = (Tag) o;
		return this.horiz.equals(t.horiz) && this.vert.equals(t.vert);
	}
}
