package org.sfb441.tradisc.eval;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.ListSelectionModel;

import org.sfb441.tradisc.Markable;


	class MarkableChooser implements ActionListener {

		private EvaluationTable caller;
		
		private DefaultListModel cmListModel;

		private DefaultListModel allListModel;

		private JDialog dialog;

		private JList chosenMarkablesList;

		private JList allMarkablesList;

		private static final String ADD = "Add selected Markable(s) to evaluation list";

		private static final String REMOVE = "Remove selected Markable(s) from evaluation list";

		private static final String CLOSE_M = "Close Markable Chooser";

		public MarkableChooser(EvaluationTable caller) {
			this.caller = caller;
			cmListModel = new DefaultListModel();
			chosenMarkablesList = new JList(cmListModel);
			chosenMarkablesList
					.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			chosenMarkablesList.setLayoutOrientation(JList.VERTICAL);
			chosenMarkablesList.setVisibleRowCount(-1);
			allListModel = new DefaultListModel();
			allMarkablesList = new JList(allListModel);
			allMarkablesList
					.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			allMarkablesList.setLayoutOrientation(JList.VERTICAL);
			allMarkablesList.setVisibleRowCount(-1);
			JScrollPane chosenListScroller = new JScrollPane(
					chosenMarkablesList);
			chosenListScroller.setPreferredSize(new Dimension(300, 250));
			JScrollPane allListScroller = new JScrollPane(allMarkablesList);
			allListScroller.setPreferredSize(new Dimension(250, 250));
			JButton removeButton = new JButton("remove markable(s)");
			removeButton.setActionCommand(REMOVE);
			removeButton.addActionListener(this);
			JButton closeb = new JButton("close");
			closeb.setActionCommand(CLOSE_M);
			closeb.addActionListener(this);
			JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
			JPanel p = new JPanel(new BorderLayout());
			JLabel l = new JLabel("All markables");
			JButton addButton = new JButton("add markable(s)");
			addButton.setActionCommand(ADD);
			addButton.addActionListener(this);
			p.add(l, BorderLayout.NORTH);
			p.add(allListScroller, BorderLayout.CENTER);
			p.add(addButton, BorderLayout.SOUTH);
			splitPane.setLeftComponent(p);
			p = new JPanel(new BorderLayout());
			l = new JLabel("selected markables");
			p.add(l, BorderLayout.NORTH);
			p.add(chosenListScroller, BorderLayout.CENTER);
			p.add(removeButton, BorderLayout.SOUTH);
			splitPane.setRightComponent(p);
			JPanel contentPane = new JPanel();
			contentPane.setLayout(new BorderLayout());
			contentPane.add(splitPane, BorderLayout.CENTER);
			p = new JPanel();
			p.add(closeb);
			contentPane.add(p, BorderLayout.SOUTH);
			dialog = new JDialog(caller.getDialog(), "markables to evaluate", true);
			dialog.setContentPane(contentPane);
			dialog.setLocationRelativeTo(caller.getDialog());
			dialog.pack();
		}

		public void show() {
			dialog.setVisible(true);
		}

		public Vector<Markable> getSelectedMarkables() {
			Enumeration e =  cmListModel.elements();
			Vector<Markable> v = new Vector<Markable>();
			while (e.hasMoreElements())	{			
				v.add((Markable)e.nextElement());
			}
			return v;
		}

		public void loadActiveMarkables() {
			Vector v = caller.getSchema().getAllMarkables();
			allListModel.clear();
			Iterator it = v.iterator();
			while (it.hasNext()) {
				allListModel.addElement(it.next());
			}
			dialog.pack();
		}

		public void clearSelectedMarkables() {
			cmListModel.clear();
			chosenMarkablesList.setModel(cmListModel);
			dialog.pack();
			caller.setAllMarkables(true);			
			caller.selectMarkableSelectionCheckBox(false);
		}

		public boolean isSelectionEmpty() {
			return cmListModel.isEmpty();
		}

		public void actionPerformed(ActionEvent e) {
			String cmd = e.getActionCommand();
			if (CLOSE_M.equals(cmd)) {
				dialog.setVisible(false);
			} else if (ADD.equals(cmd)) {
				Object[] selection = allMarkablesList.getSelectedValues();
				for (int i = 0; i < selection.length; i++)
					if (!cmListModel.contains(selection[i]))
						cmListModel.addElement(selection[i]);
			} else if (REMOVE.equals(cmd)) {
				Object[] selection = chosenMarkablesList.getSelectedValues();
				for (int i = 0; i < selection.length; i++)
					cmListModel.removeElement(selection[i]);
			}
		}
	}
