package org.sfb441.tradisc.eval;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

class NormFactorInputDialog extends JDialog implements ActionListener,
		PropertyChangeListener {

	private JOptionPane optionPane;

	private String btnString1 = "enter";

	private String btnString2 = "cancel";

	private JTextField textField;

	private String typedText = null;

	public NormFactorInputDialog(JDialog aDialog) {
		super(aDialog, true);
		this.setTitle("enter normalization factor");
		textField = new JTextField(10);
		String msgString = "enter normalization factor:";
		Object[] array = { msgString, textField };
		Object[] options = { btnString1, btnString2 };
		optionPane = new JOptionPane(array, JOptionPane.QUESTION_MESSAGE,
				JOptionPane.YES_NO_OPTION, null, options, options[0]);
		setContentPane(optionPane);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
			}
		});
		addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent ce) {
				textField.requestFocusInWindow();
			}
		});
		textField.addActionListener(this);
		optionPane.addPropertyChangeListener(this);
		this.pack();
	}

	/**
	 * die validierte Eingabe zurckfordern
	 * 
	 * @return
	 */
	public int getValidatedData() {
		try {
			int n = Integer.parseInt(typedText);
			return n;
		} catch (NumberFormatException e) {
			return 0;
		}
	}

	public void actionPerformed(ActionEvent e) {
		optionPane.setValue(btnString1);
	}

	public void propertyChange(PropertyChangeEvent e) {
		String prop = e.getPropertyName();
		if (isVisible()
				&& (e.getSource() == optionPane)
				&& (JOptionPane.VALUE_PROPERTY.equals(prop) || JOptionPane.INPUT_VALUE_PROPERTY
						.equals(prop))) {
			Object value = optionPane.getValue();
			if (value == JOptionPane.UNINITIALIZED_VALUE)
				return;
			optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
			if (btnString1.equals(value)) {
				typedText = textField.getText();
				clearAndHide();
			} else { // clear or cancel
				typedText = null;
				clearAndHide();
			}
		}
	}

	/** dialog clearen und verbergen */
	public void clearAndHide() {
		textField.setText(null);
		setVisible(false);
	}

}
