package org.sfb441.tradisc.inputformat;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Enumeration;

public class CorpusFormatWriter extends FileWriter {

	public CorpusFormatWriter(File schemaFile) throws IOException {
		super(schemaFile);
	}

	public void write(CorpusFormat corpusFormat) throws IOException {
		super.write("<?xml version='1.0' encoding='ISO-8859-1'?>\n");
		corpusFormat2xml(corpusFormat, this);
	}

	public void write(String s) throws IOException {
		super.write(s);
	}
	
	
	public static void corpusFormat2xml(CorpusFormat corpusFormat, Writer w)
			throws IOException {
		w.write("<CorpusFormat>\n");
		//token elements format
		w.write("  <token tag=\"" + corpusFormat.getTokenTag() 
				+ "\" display=\"" + corpusFormat.getTokenDisplayAttr() + "\">\n");
		w.write("    <attributes>\n");
		Enumeration e = corpusFormat.getTokenAttributeNames();
		while(e.hasMoreElements()){
			String name = (String)e.nextElement();
			String value = corpusFormat.getTokenAttribute(name);
			w.write("      <attribute name=\"" + name + "\" value=\"" + value + "\"/>\n");
		}
		w.write("    </attributes>\n");
		w.write("  </token>\n");
		
		w.write("  <otherDisplayElements tag=\"" + corpusFormat.getOtherTag() 
				+ "\" display=\"" + corpusFormat.getOtherDisplayAttr() + "\">\n");
		w.write("    <attributes>\n");
		e = corpusFormat.getOtherAttributeNames();
		while(e.hasMoreElements()){
			String name = (String)e.nextElement();
			String value = corpusFormat.getOtherAttribute(name);
			w.write("      <attribute name=\"" + name + "\" value=\"" + value + "\"/>\n");
		}
		w.write("    </attributes>\n");
		w.write("  </otherDisplayElements>\n");		
		w.write("</CorpusFormat>\n");
	}


}