package org.sfb441.tradisc.schema;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SpringLayout;
import javax.swing.table.DefaultTableModel;

import org.sfb441.tradisc.Markable;
import org.sfb441.tradisc.SwingUtilities;

public class MarkableInputDialog extends JDialog implements ActionListener {

	private final SchemaCellEditor editor;

	private final static String ATTRIBDELETE = "attrib_delete";

	private final static String ATTRIBADD = "attrib_add";

	private boolean isEditDialog = false;

	// TODO auskommentiert sind eingabekomponenten fr markable xml tag
	// value, bei bedarf wieder einkommentieren
	// private JTextField textFieldValue;
	private JTextField textFieldTag;

	private JTextField textFieldAttrName;

	private JTextField textFieldAttrValue;

	private JTable attribTable;

	private DefaultTableModel attribTm;

	private Hashtable<String, String> attribListData;

	private JLabel verifyLabel;

	private JCheckBox noMarkableCheckBox;

	private final static String ENTER = "enter";

	private final static String CANCEL = "cancel";

	private final static String VERIFY = "verify";

	private JOptionPane optionPane;

	private Markable enteredMarkable;

	/** Creates the dialog. */
	protected MarkableInputDialog(SchemaCellEditor editor) {
		super(editor.getSchemaEditor().getGui().getGuiFrame(), true);
		this.editor = editor;

		setTitle("edit markable entry");

		// "verify" Label
		verifyLabel = new JLabel(" ");

		// tag name and tag value
		// textFieldValue = new JTextField(20);
		// JLabel textFieldValueDescr = new JLabel("XML tag value: ");
		textFieldTag = new JTextField(20);
		JLabel textFieldTagDescr = new JLabel("XML tag name: ");

		JPanel tagnameAndValuePanel = new JPanel(new SpringLayout());
		tagnameAndValuePanel.add(textFieldTagDescr);
		tagnameAndValuePanel.add(textFieldTag);
		// tagnameAndValuePanel.add(textFieldValueDescr);
		// tagnameAndValuePanel.add(textFieldValue);
		SwingUtilities.makeCompactGrid(tagnameAndValuePanel, 1, 2, 3, 3, 2, 2);

		// attribs
		textFieldAttrName = new JTextField(20);
		textFieldAttrValue = new JTextField(20);

		attribListData = new Hashtable<String, String>();
		attribTm = new DefaultTableModel();
		attribTm.addColumn("attribute name");
		attribTm.addColumn("attribute value");
		attribTable = new JTable(attribTm);
		attribTable.setPreferredScrollableViewportSize(new Dimension(300, 100));
		attribTable.getTableHeader().setReorderingAllowed(false);
		JScrollPane attribListSp = new JScrollPane(attribTable);

		JButton addAttributesButton = new JButton("add");
		JButton delAttributesButton = new JButton("remove");

		ActionListener attributeEditListener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String cmd = e.getActionCommand();
				System.err.println("[attribute edit] " + cmd);
				if (ATTRIBADD.equals(cmd)) {
					String an = textFieldAttrName.getText();
					String av = textFieldAttrValue.getText();
					if (an.equals("")) {
						JOptionPane.showMessageDialog(null,
								"Enter attribute name");
						return;
					} else if (attribListData.containsKey(an)) {
						JOptionPane.showMessageDialog(null,
								"Attribute with this name already exists");
						return;
					}

					Object[] data = { an, av };
					attribTm.addRow(data);
					attribListData.put(an, av); // data array for export
				} else if (ATTRIBDELETE.equals(cmd)) {
					if (attribTable.getRowCount() == 0) {
						return;
					} else if (attribTable.getSelectedRowCount() == 0) {
						JOptionPane.showMessageDialog(null,
								"Select attribute to remove");
						return;
					}
					Object an = attribTm.getValueAt(attribTable
							.getSelectedRow(), 0);
					attribListData.remove(an);
					attribTm.removeRow(attribTable.getSelectedRow());
				}
			}
		};

		addAttributesButton.addActionListener(attributeEditListener);
		addAttributesButton.setActionCommand(ATTRIBADD);
		addAttributesButton.setMnemonic(KeyEvent.VK_A);
		delAttributesButton.addActionListener(attributeEditListener);
		delAttributesButton.setActionCommand(ATTRIBDELETE);
		addAttributesButton.setMnemonic(KeyEvent.VK_R);

		JPanel attributeButtons = new JPanel();
		attributeButtons.setLayout(new GridLayout(2, 0));
		attributeButtons.add(addAttributesButton);
		attributeButtons.add(delAttributesButton);

		JPanel contentPanelTagAttribsInput1 = new JPanel();
		contentPanelTagAttribsInput1.setBorder(BorderFactory.createEmptyBorder(
				5, 5, 5, 5));
		contentPanelTagAttribsInput1.setLayout(new GridLayout(2, 2));
		contentPanelTagAttribsInput1.add(new JLabel(
				"XML attributes (name/value pairs):"));
		contentPanelTagAttribsInput1.add(new JLabel(" "));
		contentPanelTagAttribsInput1.add(textFieldAttrName);
		contentPanelTagAttribsInput1.add(textFieldAttrValue);
		JPanel contentPanelTagAttribsInput2 = new JPanel();
		contentPanelTagAttribsInput2.setLayout(new BoxLayout(
				contentPanelTagAttribsInput2, BoxLayout.PAGE_AXIS));
		contentPanelTagAttribsInput2.add(contentPanelTagAttribsInput1);
		contentPanelTagAttribsInput2.add(attribListSp);

		JPanel contentPanelTagAttribsInput = new JPanel();
		contentPanelTagAttribsInput.setLayout(new BoxLayout(
				contentPanelTagAttribsInput, BoxLayout.PAGE_AXIS));
		contentPanelTagAttribsInput.add(contentPanelTagAttribsInput1);
		contentPanelTagAttribsInput.add(contentPanelTagAttribsInput2);

		JPanel contentPanelTagAttribs = new JPanel();
		contentPanelTagAttribs.add(contentPanelTagAttribsInput);
		contentPanelTagAttribs.add(attributeButtons);

		// kategorie "keine Kategorie" -> geregelt ber Checkbox
		noMarkableCheckBox = new JCheckBox(
				"this element is sometimes not a markable");
		JPanel noMarkablePanel = new JPanel();
		noMarkablePanel.add(noMarkableCheckBox);

		JPanel contentPanelTagData = new JPanel();
		contentPanelTagData.setLayout(new BoxLayout(contentPanelTagData,
				BoxLayout.PAGE_AXIS));
		contentPanelTagData.add(tagnameAndValuePanel);
		contentPanelTagData.add(contentPanelTagAttribs);
		contentPanelTagData.add(noMarkablePanel);
		contentPanelTagData
				.setBorder(BorderFactory
						.createTitledBorder("describe the XML-Tag that contains the markable"));

		// verify label
		JPanel contentPanelPreview = new JPanel();
		contentPanelPreview.add(verifyLabel);
		contentPanelPreview.setBorder(BorderFactory
				.createTitledBorder("preview"));

		JPanel contentPanel = new JPanel();
		contentPanel
				.setLayout(new BoxLayout(contentPanel, BoxLayout.PAGE_AXIS));
		contentPanel.add(contentPanelTagData);
		contentPanel.add(contentPanelPreview);
		Object[] array = { contentPanel };

		// Create an array specifying the number of dialog buttons
		// and their text.
		JPanel buttonPanel = new JPanel();
		JButton controlButton = new JButton(ENTER);
		controlButton.setMnemonic(KeyEvent.VK_E);
		controlButton.setActionCommand(ENTER);
		controlButton.addActionListener(this);
		buttonPanel.add(controlButton);
		controlButton = new JButton(CANCEL);
		controlButton.setMnemonic(KeyEvent.VK_C);
		controlButton.setActionCommand(CANCEL);
		controlButton.addActionListener(this);
		buttonPanel.add(controlButton);
		controlButton = new JButton(VERIFY);
		controlButton.setMnemonic(KeyEvent.VK_V);
		controlButton.setActionCommand(VERIFY);
		controlButton.addActionListener(this);
		buttonPanel.add(controlButton);
		Object[] options = { buttonPanel };

		// Create the JOptionPane.
		optionPane = new JOptionPane(array, JOptionPane.PLAIN_MESSAGE,
				JOptionPane.YES_NO_OPTION, null, options, options[0]);

		// Make this dialog display it.
		setContentPane(optionPane);

		// Handle window closing correctly.
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
			}
		});

		// Ensure the text field always gets the first focus.
		addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent ce) {
				textFieldAttrName.requestFocusInWindow();
			}
		});

		// Register event handlers that puts the output into the option
		// pane.
		textFieldTag.addActionListener(this);
		// textFieldValue.addActionListener(this);

		// Register an event handler that reacts to option pane state
		// changes.
		// optionPane.addPropertyChangeListener(this);

	}

	public void showMarkableEditDialog(boolean isEditDialog) {
		this.isEditDialog = isEditDialog;
		if (!isEditDialog) {
			textFieldTag.setText(editor.getSchemaEditor().getGui().getCorpusFormatEditor().getCorpusFormat()
					.getTokenTag());
		}
		this.setVisible(true);
	}

	/**
	 * loads a already existing markable into the editor
	 */
	public void loadMarkable(String name, Hashtable<String, String> attrib,
			boolean isNonElement) {
		enteredMarkable = null;
		textFieldTag.setText(name);
		// textFieldValue.setText(value);
		attribListData = attrib;
		Enumeration enumeration = attribListData.keys();
		while (enumeration.hasMoreElements()) {
			String an = (String) enumeration.nextElement();
			String av = attribListData.get(an);
			Object[] data = { an, av };
			attribTm.addRow(data);
		}
		// mssen wir die checkbox ankreuzen, d.h. ist das zu
		// editierende Element in der nonElements-Liste vorhanden?
		noMarkableCheckBox.setSelected(isNonElement);
	}

	/**
	 * pre-sets the "no markable" checkbox
	 */
	public void setNoMarkableCheckBox(boolean b) {
		noMarkableCheckBox.setSelected(b);
	}

	/**
	 * Returns the data contained in the form as
	 * 
	 * @link{Markable}
	 */
	public Markable getValidatedMarkable() {
		if (enteredMarkable == null) {
			System.err.println("markable is null");
		}
		return enteredMarkable;
	}

	/** This method handles events for the text fields. */
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		System.err.println("[SchemaEditor.MarkableInputDialog]: " + cmd);
		if (ENTER.equals(cmd)) {
			if (textFieldTag.getText().equals("")) {
				JOptionPane.showMessageDialog(MarkableInputDialog.this,
						"You have to enter a tag name.\n", "Error",
						JOptionPane.ERROR_MESSAGE);
				textFieldTag.requestFocusInWindow();
				return;
			}
			// Markable m = new Markable(this.textFieldTag.getText(),
			// this.textFieldValue.getText(), this.attribListData);
			Markable m = new Markable(this.textFieldTag.getText(),
					this.attribListData);
			// nicht zweimal das gleiche Element eingeben.
			Enumeration enumeration = editor.getCellContentElements();
			while (enumeration.hasMoreElements()) {
				if (m.equals(enumeration.nextElement()) && !isEditDialog) {
					JOptionPane.showMessageDialog(MarkableInputDialog.this,
							"Sorry, this markable is already in the list.\n",
							"Try again", JOptionPane.ERROR_MESSAGE);
					textFieldTag.requestFocusInWindow();
					return;
				}
			}
			enteredMarkable = m;
			clearAndHide();
		} else if (CANCEL.equals(cmd)) {
			System.err.println("Cancel");
			enteredMarkable = null;
			clearAndHide();
		} else if (VERIFY.equals(cmd)) {
			// verify/preview entered data
			// use the markable class to build a text rep
			// Markable vm = new Markable(textFieldTag.getText(),
			// textFieldValue.getText(), attribListData);
			Markable vm = new Markable(textFieldTag.getText(), attribListData);
			verifyLabel.setText(vm.toString());
		}
	}

	/** This method clears the dialog and hides it. */
	public void clearAndHide() {
		// textFieldValue.setText(null);
		textFieldTag.setText(null);
		textFieldAttrName.setText(null);
		textFieldAttrValue.setText(null);
		verifyLabel.setText(" ");
		attribListData = new Hashtable<String, String>();
		attribTm.setRowCount(0);
		isEditDialog = false;
		setVisible(false);
	}

	protected boolean isNoMarkableBoxSelected(){
		return noMarkableCheckBox.isSelected();
	}
	
}
